apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: mongodb
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: {{ mongodb_name }}
    backups.opsperator.io/service: {{ mongodb_name }}-ready
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ mongodb_name }}
  name: {{ mongodb_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: OrderedReady
  replicas: {{ mongodb_replicas }}
  selector:
    matchLabels:
      name: {{ mongodb_name }}
  serviceName: {{ mongodb_name }}
  template:
    metadata:
      labels:
        name: {{ mongodb_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities | default(True) %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ mongodb_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ mongodb_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - args:
        - /usr/bin/run-mongod-replication
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: MONGODB_ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-admin-password
              name: {{ mongodb_name }}
        - name: MONGODB_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ mongodb_name }}
{% if mongodb_expose_local | default(False) %}
        - name: MONGODB_EXPOSE_LOCAL
          value: yay
{% endif %}
        - name: MONGODB_KEYFILE_VALUE
          valueFrom:
            secretKeyRef:
              key: database-keyfile
              name: {{ mongodb_name }}
        - name: MONGODB_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ mongodb_name }}
        - name: MONGODB_REPLICA_NAME
          valueFrom:
            secretKeyRef:
              key: database-replicaname
              name: {{ mongodb_name }}
        - name: MONGODB_SERVICE_NAME
          value: {{ mongodb_name }}
        - name: TZ
          value: {{ timezone }}
        - name: MONGODB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ mongodb_name }}
        image: {{ (opsimages | json_query("[?name=='mongodb'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 10
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 27017
          timeoutSeconds: 5
        name: mongodb
        ports:
        - containerPort: 27017
        readinessProbe:
          exec:
            command:
            - /bin/sh
            - -i
            - -c
{% if only_expose_master | default(False) %}
            - /usr/bin/is-master.sh
          initialDelaySeconds: 10
          timeoutSeconds: 5
{% else %}
            - 'mongo 127.0.0.1:27017/$MONGODB_DATABASE -u $MONGODB_USER -p $MONGODB_PASSWORD --eval="quit()"'
          initialDelaySeconds: 10
          timeoutSeconds: 2
{% endif %}
        resources:
          limits:
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
          requests:
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
        volumeMounts:
        - mountPath: /var/lib/mongodb/data
          name: data
{% if do_exporters %}
      - args:
        - "--mongodb.uri={{ mg_metrics_url }}"
        image: {{ (opsimages | json_query("[?name=='mongoexporter'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
{% else %}
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% endif %}
        volumeMounts:
        - mountPath: /tmp
          name: run
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
      terminationGracePeriodSeconds: {{ mongodb_termination_timeout | default(600) }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ mongodb_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - emptyDir: {}
        name: run
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ mongodb_data_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
